import { computed, watch, type Ref, watchEffect, nextTick } from 'vue';

export const useClickOther = (
	excludeEle: Ref<HTMLElement>[] | Ref<HTMLElement>,
	isShow: Ref<boolean>,
	handleClickOther: () => void = () => {
		isShow.value = false;
	}
) => {
	const domList = computed(() => {
		const computedEle = Array.isArray(excludeEle) ? excludeEle : [excludeEle];
		return computedEle.map((item) => item.value?.$el).filter(item=>!!item);
	});


	
	const listenClickOtherExit = (e) => {
		if (!domList.value.includes(e.target) && domList.value.every((item) => !item.contains(e.target))) {
			handleClickOther();
		}
	};

	watch(isShow, (val) => {
		if (val) {
			setTimeout(() => {
				document.addEventListener('click', listenClickOtherExit);
			}, 0);
		} else {
			document.removeEventListener('click', listenClickOtherExit);
		}
	});
};
